@mixin placeholderize($color,$font-family,$text-transform,$size,$padding){
  ::-webkit-input-placeholder {
    color: $color;
    font-family: $font-family;
    font-size: $size;
    text-transform: $text-transform;
    padding-top:$padding;
  }

  :-moz-placeholder { /* Firefox 18- */
    color: $color;
    font-family: $font-family;
    font-size: $size;
    text-transform: $text-transform;
    padding-top:$padding;
  }

  ::-moz-placeholder {  /* Firefox 19+ */
    color: $color;
    font-family: $font-family;
    font-size: $size;
    text-transform: $text-transform;
    padding-top:$padding;
  }

  :-ms-input-placeholder {
    color: $color;
    font-family: $font-family;
    font-size: $size;
    text-transform: $text-transform;
    padding-top:$padding;
  }

}

//================================== Colors ======================================//

@mixin colorize($color:inherit,$bgcolor:inherit){
  color: $color;
  background-color: $bgcolor;
}

@mixin linear-gradient($fromColor, $toColor) {
  background-color: $toColor; /* Fallback Color */
  background-image: -webkit-gradient(linear, left top, left bottom, from($fromColor), to($toColor)); /* Saf4+, Chrome */
  background-image: -webkit-linear-gradient(top, $fromColor, $toColor); /* Chrome 10+, Saf5.1+, iOS 5+ */
  background-image:    -moz-linear-gradient(top, $fromColor, $toColor); /* FF3.6 */
  background-image:     -ms-linear-gradient(top, $fromColor, $toColor); /* IE10 */
  background-image:      -o-linear-gradient(top, $fromColor, $toColor); /* Opera 11.10+ */
  background-image:         linear-gradient(top, $fromColor, $toColor);
  filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0,StartColorStr='#{$fromColor}', EndColorStr='#{$toColor}');
}

//================================== Extras ======================================//

@mixin roundify($radius:5px){
  -webkit-border-radius: $radius;
  -moz-border-radius: $radius;
  border-radius: $radius;
}


@mixin box-shadow($top, $left, $blur, $size, $color, $inset: false) {
    @if $inset {
      @include vendor-prefix(box-shadow, inset $top $left $blur $size $color);
    } @else {
      @include vendor-prefix(box-shadow, $top $left $blur $size $color);
    }
}

//============= Fancy Link Underlines ========== //

@mixin text-underline-crop($background) {
  text-shadow:  .03em 0 $background, 
                -.03em 0 $background,
                0 .03em $background,
                0 -.03em $background,
                .06em 0 $background,
                -.06em 0 $background,
                .09em 0 $background,
                -.09em 0 $background,
                .12em 0 $background,
                -.12em 0 $background,
                .15em 0 $background,
                -.15em 0 $background;
}

@mixin text-underline($color-bg, $color-text) {
  background-image: linear-gradient($color-text, $color-text);
  background-size: 1px 1px;
  background-repeat: repeat-x;
  background-position: 0% 95%;
}

@mixin text-selection($selection) {
  &::selection {
    @include text-underline-crop($selection);
    
    background: $selection;
  }

  &::-moz-selection {
    @include text-underline-crop($selection);
    
    background: $selection;
  }
}

@mixin link-underline($background, $text, $selection){
  @include text-underline-crop($background);
  @include text-underline($background, $text);
  @include text-selection($selection);

  color: $text;
  text-decoration: none;

  *,
  *:after,
  &:after,
  *:before,
  &:before {
    text-shadow: none;
  }

  &:visited {
    color: $text;
  }
}

$color-text:        #333332;
$color-background:  #fff;
$color-selection:   #b4d5fe;
